import { CodeLens, CompletionItem, Position, Range } from "vscode-languageserver-types";
export interface DashbuilderLanguageServiceChannelApi {
    kogitoDashbuilderLanguageService__getCompletionItems(args: {
        content: string;
        uri: string;
        cursorPosition: Position;
        cursorWordRange: Range;
    }): Promise<CompletionItem[]>;
    kogitoDashbuilderLanguageService__getCodeLenses(args: {
        uri: string;
        content: string;
    }): Promise<CodeLens[]>;
}
export declare type DashbuilderLanguageServiceCommandTypes = "dashbuilder.ls.commands.OpenCompletionItems";
export declare type DashbuilderLanguageServiceCommandArgs = {
    "dashbuilder.ls.commands.OpenCompletionItems": {
        newCursorPosition: Position;
    };
};
export declare type DashbuilderLanguageServiceCommandIds = Record<DashbuilderLanguageServiceCommandTypes, string>;
export declare type DashbuilderLanguageServiceCommandHandlers = {
    [K in DashbuilderLanguageServiceCommandTypes]: (args: DashbuilderLanguageServiceCommandArgs[K]) => any;
};
export interface DashbuilderLanguageServiceCommandExecution<T extends DashbuilderLanguageServiceCommandTypes> {
    name: T;
    args: DashbuilderLanguageServiceCommandArgs[T];
}
//# sourceMappingURL=DashbuilderLanguageServiceChannelApi.d.ts.map