import { CodeLens, CompletionItem, Diagnostic, Position, Range } from "vscode-languageserver-types";
import { DashbuilderJsonPath, DashbuilderLsNode } from "./types";
export declare class DashbuilderLanguageService {
    constructor();
    parseContent(content: string): DashbuilderLsNode | undefined;
    getCompletionItems(args: {
        content: string;
        uri: string;
        cursorPosition: Position;
        cursorWordRange: Range;
    }): Promise<CompletionItem[]>;
    getCodeLenses(args: {
        content: string;
        uri: string;
    }): Promise<CodeLens[]>;
    getDiagnostics(args: {
        content: string;
        uriPath: string;
    }): Promise<Diagnostic[]>;
    private getSchemaDiagnostics;
    dispose(): void;
}
export declare function findNodeAtOffset(root: DashbuilderLsNode, offset: number, includeRightBound?: boolean): DashbuilderLsNode | undefined;
export declare function getNodePath(node: DashbuilderLsNode): DashbuilderJsonPath;
export declare const isNodeUncompleted: (args: {
    content: string;
    uri: string;
    rootNode: DashbuilderLsNode;
    cursorOffset: number;
}) => boolean;
export declare const positions_equals: (a: Position | null, b: Position | null) => boolean;
//# sourceMappingURL=DashbuilderLanguageService.d.ts.map