"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DashbuilderLanguageServiceCodeCompletion = void 0;
var vscode_languageserver_types_1 = require("vscode-languageserver-types");
var code_completions_1 = require("../assets/code-completions/");
var indentText_1 = require("./indentText");
var DashbuilderLanguageService_1 = require("./DashbuilderLanguageService");
var yaml_language_server_parser_1 = require("yaml-language-server-parser");
var translateYamlDoc = function (args) {
    var _a, _b, _c, _d;
    var completionDump = (0, yaml_language_server_parser_1.dump)(args.completion, {}).slice(2, -1).trim();
    if (["{}", "[]"].includes(completionDump) || args.completionItemKind === vscode_languageserver_types_1.CompletionItemKind.Text) {
        return completionDump;
    }
    var skipFirstLineIndent = args.completionItemKind !== vscode_languageserver_types_1.CompletionItemKind.Module;
    var completionItemNewLine = args.completionItemKind === vscode_languageserver_types_1.CompletionItemKind.Module ? "\n" : "";
    var completionText = completionItemNewLine + (0, indentText_1.indentText)(completionDump, 2, " ", skipFirstLineIndent);
    return [vscode_languageserver_types_1.CompletionItemKind.Interface, vscode_languageserver_types_1.CompletionItemKind.Reference].includes(args.completionItemKind) && (0, DashbuilderLanguageService_1.positions_equals)((_b = (_a = args.overwriteRange) === null || _a === void 0 ? void 0 : _a.start) !== null && _b !== void 0 ? _b : null, (_d = (_c = args.currentNodeRange) === null || _c === void 0 ? void 0 : _c.start) !== null && _d !== void 0 ? _d : null)
        ? "- ".concat(completionText, "\n")
        : completionText;
};
exports.DashbuilderLanguageServiceCodeCompletion = {
    getEmptyFileCodeCompletions: function (args) {
        var kind = vscode_languageserver_types_1.CompletionItemKind.Text;
        var label = "Create your first dashboard";
        return [
            {
                kind: kind,
                label: label,
                detail: "Start with a simple dashboard",
                sortText: "100_".concat(label),
                textEdit: {
                    newText: translateYamlDoc(__assign(__assign({}, args), { completion: code_completions_1.dashbuilderCompletion, completionItemKind: kind })),
                    range: vscode_languageserver_types_1.Range.create(args.cursorPosition, args.cursorPosition),
                },
                insertTextFormat: vscode_languageserver_types_1.InsertTextFormat.Snippet,
            },
        ];
    },
};
//# sourceMappingURL=DashbuilderLanguageServiceCodeCompletion.js.map