import { TextDocument } from "vscode-languageserver-textdocument";
import { CompletionItemKind, Range } from "vscode-languageserver-types";
export declare type DashbuilderLsNodeType = "object" | "array" | "property" | "string" | "number" | "boolean" | "null";
export declare type DashbuilderJsonPath = (string | number)[];
export declare type DashbuilderLsNode = {
    type: DashbuilderLsNodeType;
    value?: any;
    offset: number;
    length: number;
    colonOffset?: number;
    parent?: DashbuilderLsNode;
    children?: DashbuilderLsNode[];
};
export interface TranslateArgs {
    completion: object | string;
    completionItemKind: CompletionItemKind;
    currentNodeRange?: Range;
    cursorOffset: number;
    document: TextDocument;
    overwriteRange?: Range;
}
//# sourceMappingURL=types.d.ts.map